//*******************************************************
// GAA[V[ANZ[^M@ (accelerator_rx)
// (c)2007 Ryosuke Kawano
// URL: http://www.cts-net.ne.jp/~kawano-r/
// MCU: MC908QY4A with Serial Monitor
// Compiler: CodeWarrior HC08 V5.1 Special Edition
// 9.Apr.2007  Ver.1.0  GLWbNNo.2Ŕ\
//*******************************************************

#include <hidef.h>
#include <startup.h>
#include "derivative.h"

typedef unsigned char   U1;
typedef unsigned int    U2;
typedef signed int      S2;

//*************************
// }N̒`
//*************************

// ANZx
#define PORT_RXIN1      PTB_PTB2

#define LEVEL0_TIME     ( ( U1 )( 100. * 1000. / 624. ) )
#define LEVEL1_2_TIME   ( ( U1 )( 60. * 1000. / 624. ) )
#define LEVEL3_TIME     ( ( U1 )( 100. * 1000. / 624. ) )

// MmF
#define PORT_RXIN2      PTB_PTB3

// PWMo͏
// ^C} 1s ~ 104 = 104s
#define PERIOD          ( 104 )

#define PORT_ACCEL      PTB_PTB4
#define PORT_REVERSE    PTB_PTB5

#define DIR_ACCEL       DDRB_DDRB4
#define DIR_REVERSE     DDRB_DDRB5

#define DIR_INPUT       ( 0 )
#define DIR_OUTPUT      ( 1 )

// LEDo͏
#define PORT_LED        PTA_PTA5

#define LED_ON          ( 1 )
#define LED_OFF         ( 0 )

#define LED_PERIOD      ( ( U1 )( 1000. / 10. ) )
#define FLASH_TIME      ( ( U1 )( 100. / 10. ) )

//*************************
// f[^̒`
//*************************

// S
volatile U1 U1_main_timing;
volatile U1 U1_fast_timing;

// ANZx
U1 U1_accel;

// MmF
U1 U1_accel_reverse;

// ANZo[X
U1 U1_fwd_rev;
U2 U2_pwm_data;

//*************************
// ֐vg^Cv錾
//*************************

void init_hardware( void );
void init_PORT( void );
void init_TIM( void );

void accel_int( void );         // ANZxi荞݁j
void rx_check( void );	        // MmF
void accel_reverse( void );	    // ANZo[X
void pwm_output( void );        // PWMo͏
void led_output( void );        // LEDo͏

//*************************
// C
//*************************

void main( void ) {
    init_hardware( );
    init_PORT( );
    init_TIM( );
    
    EnableInterrupts;
    
    for ( ; ; ) {
        __RESET_WATCHDOG( );

        if ( U1_fast_timing == 1 ){
            U1_fast_timing = 0; // 624s Ɏs
            // ̎sԂ͎ 380s
            accel_int( );       // ANZx
        }

        if ( U1_main_timing == 1 ){
            U1_main_timing = 0; // 10ms Ɏs
            // C̎sԂ͎ 440s
            
            rx_check( );        // MmF
            
            accel_reverse( );   // ANZo[X
            
            pwm_output( );      // PWMo͏
            
            led_output( );      // LEDo͏
        }
    }
}

//*************************
// Zbg̏
//*************************

void init_hardware( void ) {
    CONFIG2 = 0x00;     // IRQs֎~
    CONFIG1 = 0x20;     // LVIASTOPACOPL
    OSCTRIM = Optional; 
    OSCSC = 0x00;       // OSC 4MHz
}

void init_PORT( void ) {
    PTAPUE = 0x00;
    // PTA_PTA0, DDRA_DDRA0 ̓ANZX֎~
    PTA_PTA1 = 0;
    PTA_PTA3 = 0;
    PTA_PTA4 = 0;
    PTA_PTA5 = 0;
    DDRA_DDRA1 = 1;
    DDRA_DDRA3 = 1;
    DDRA_DDRA4 = 1;
    DDRA_DDRA5 = 1;
    PTBPUE = 0x00;
    PTB    = 0x00;
    DDRB   = 0xF3;
}

void init_TIM( void ) {
    TSC = 0x30;         // ^C}~A^C}ZbgAȂ
    TMOD = PERIOD - 1;
    TSC1 = 0x18;        // obt@ȂPWM, Active High
    TCH1 = 0;
    TSC = 0x40;         // TOF 荞݋A^C}X^[g
}

//*************************
// ANZx
//*************************
void accel_int( void ){
static U1 U1s_timer, U1s_lv0_timer;
static U1 U1s_indata_old;
static enum {
    STATE_STOP,
    STATE_LEVEL1,
    STATE_LEVEL2,
    STATE_LEVEL3
} ens_accel_state;
U1 U1t_indata;
    
    U1t_indata = PORT_RXIN1;
    if ( U1s_lv0_timer < LEVEL0_TIME ){
        U1s_lv0_timer++;
    }
    if ( U1t_indata == 1 ){
        U1s_lv0_timer = 0;
    }
    switch ( ens_accel_state ){
    case STATE_STOP:
        U1_accel = 0;
        // yPz
        if ( U1t_indata == 1 ){
            U1s_timer = 0;
            U1_accel = 1;
            ens_accel_state = STATE_LEVEL1;
        }
        break;
    case STATE_LEVEL1:
        U1_accel = 1;
        if ( U1s_timer <= LEVEL1_2_TIME ){
            U1s_timer++;
        }
        if ( ( U1s_indata_old == 0 )
          && ( U1t_indata == 1 ) ){
            U1s_timer = 0;
        }
        // yQz
        if ( ( U1s_timer == LEVEL1_2_TIME )
          && ( U1t_indata == 1 ) ){
            U1_accel = 2;
            ens_accel_state = STATE_LEVEL2;
        } else {
            // yRz
            if ( U1s_lv0_timer >= LEVEL0_TIME ){
                U1_accel = 0;
                ens_accel_state = STATE_STOP;
            }
        }
        break;
    case STATE_LEVEL2:
        U1_accel = 2;
        if ( U1s_timer <= LEVEL3_TIME ){
            U1s_timer++;
        }
        if ( ( U1s_indata_old == 0 )
          && ( U1t_indata == 1 ) ){
            U1s_timer = 0;
        }
        // ySz
        if ( ( U1s_timer == LEVEL3_TIME )
          && ( U1t_indata == 1 ) ){
            U1_accel = 3;
            ens_accel_state = STATE_LEVEL3;
        } else {
            // yTz
            if ( ( U1s_timer == LEVEL1_2_TIME )
              && ( U1t_indata == 0 ) ){
                U1_accel = 1;
                ens_accel_state = STATE_LEVEL1;
            } else {
                // yUz
                if ( U1s_lv0_timer >= LEVEL0_TIME ){
                    U1_accel = 0;
                    ens_accel_state = STATE_STOP;
                }
            }
        }
        break;
    case STATE_LEVEL3:
        U1_accel = 3;
        if ( U1s_timer <= LEVEL3_TIME ){
            U1s_timer++;
        }
        if ( ( U1s_indata_old == 0 )
          && ( U1t_indata == 1 ) ){
            U1s_timer = 0;
        }
        // yVz
        if ( ( U1s_timer == LEVEL1_2_TIME )
          && ( U1t_indata == 0 ) ){
            U1_accel = 1;
            ens_accel_state = STATE_LEVEL1;
        } else {
            // yWz
            if ( ( U1s_timer == LEVEL3_TIME )
              && ( U1t_indata == 0 ) ){
                U1_accel = 2;
                ens_accel_state = STATE_LEVEL2;
            } else {
                // yXz
                if ( U1s_lv0_timer >= LEVEL0_TIME ){
                    U1_accel = 0;
                    ens_accel_state = STATE_STOP;
                }
            }
        }
        break;
    default:
        ens_accel_state = STATE_STOP;
        break;
    }
    U1s_indata_old = U1t_indata;
}

//*************************
// MmF
//*************************
void rx_check( void ) {
    U1_accel_reverse = U1_accel;
    if ( PORT_RXIN2 == 1 ){
        U1_accel_reverse = 4;
    }
}

//*************************
// ANZo[X
//*************************
void accel_reverse( void ) {
    
    switch ( U1_accel_reverse ){
    case 1:
        U1_fwd_rev = 1;
        U2_pwm_data = ( U2 )( 80. / 100. * 104. );
        break;
    case 2:
        U1_fwd_rev = 1;
        U2_pwm_data = ( U2 )( 90. / 100. * 104. );
        break;
    case 3:
        U1_fwd_rev = 1;
        U2_pwm_data = ( U2 )( 100. / 100. * 104. );
        break;
    case 4:
        U1_fwd_rev = 2;
        U2_pwm_data = ( U2 )( 90. / 100. * 104. );
        break;
    default:
        U1_fwd_rev = 0;
        U2_pwm_data = ( U2 )( 0. / 100. * 104. );
        break;
    }
}

//*************************
// PWMo͏
//*************************
void pwm_output( void ){
static U2 U2s_pwm_data_old;

    if ( U1_fwd_rev == 1 ){
        DIR_ACCEL = DIR_INPUT;
        DIR_REVERSE = DIR_OUTPUT;
    } else if ( U1_fwd_rev == 2 ){
        DIR_ACCEL = DIR_OUTPUT;
        DIR_REVERSE = DIR_INPUT;
    } else {
        DIR_ACCEL = DIR_OUTPUT;
        DIR_REVERSE = DIR_OUTPUT;
    }
    PORT_ACCEL = 0;
    PORT_REVERSE = 0;
    
    if ( U2_pwm_data >= PERIOD ){
            TSC1_ELS1A = 1;
            TSC1_CH1MAX = 1;
            TSC1_TOV1 = 0;
    } else {
        if ( U2_pwm_data != U2s_pwm_data_old ){
            if ( U2_pwm_data == 0 ){
                TSC1_ELS1A = 0;
                TSC1_CH1MAX = 0;
                TSC1_TOV1 = 0;
            } else {
                TSC1_ELS1A = 0;
                TSC1_CH1MAX = 0;
                TSC1_TOV1 = 1;
            }
            TCH1 = U2_pwm_data;
        }
    }
    U2s_pwm_data_old = U2_pwm_data;
}

//*************************
// LEDo͏
//*************************
void led_output( void ){
static U1 U1s_led_timer;

    if ( U1_accel_reverse == 0 ){
        U1s_led_timer++;
        if ( U1s_led_timer >= LED_PERIOD ){
            U1s_led_timer = 0;
        }
        if ( U1s_led_timer < FLASH_TIME ){
            PORT_LED = LED_ON;
        }else{
            PORT_LED = LED_OFF;
        }
    } else {
        PORT_LED = LED_ON;
        U1s_led_timer = 0;
    }
}

//*************************
// 荞ݏ
//*************************

// A to D Converter
#pragma TRAP_PROC
void _ADC_Interrupt( void ) {
}

// Keyboard Wakeup
#pragma TRAP_PROC
void _KBD_Interrupt( void ) {
}

// Timer Overflow
#pragma TRAP_PROC
void _TOF_Interrupt( void ) {
static U1 U1s_count1, U1s_count2;
    
    // 104s Ɋ荞ݎs
    TSC_TOF = 0;
    
    U1s_count1++;

    if ( U1s_count1 >= 6 ){
        // 624s ɍ^C~Oʒm
        U1_fast_timing = 1;
        U1s_count1 = 0;
        
        U1s_count2++;
        if ( U1s_count2 >= 16 ){
            // 10ms ɃC^C~Oʒm
            U1_main_timing = 1;
            U1s_count2 = 0;
        }
    }
}

// Timer Channel 1
#pragma TRAP_PROC
void _TCH1_Interrupt( void ) {
//    TSC1_CH1F = 0;
}

// Timer Channel 0
#pragma TRAP_PROC
void _TCH0_Interrupt( void ) {
}

// IRQ
#pragma TRAP_PROC
void _IRQ_Interrupt( void ) {
}

// End Of File
